// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: dsepractice/chinese/v1alpha1/core_types.proto

package gg.dsepractice.chinese.v1alpha1;

/**
 * Protobuf type {@code dsepractice.chinese.v1alpha1.ListArticlesResponse}
 */
public  final class ListArticlesResponse extends
    com.google.protobuf.GeneratedMessageLite<
        ListArticlesResponse, ListArticlesResponse.Builder> implements
    // @@protoc_insertion_point(message_implements:dsepractice.chinese.v1alpha1.ListArticlesResponse)
    ListArticlesResponseOrBuilder {
  private ListArticlesResponse() {
    articles_ = emptyProtobufList();
  }
  public static final int ARTICLES_FIELD_NUMBER = 1;
  private com.google.protobuf.Internal.ProtobufList<gg.dsepractice.chinese.v1alpha1.Article> articles_;
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
   */
  @java.lang.Override
  public java.util.List<gg.dsepractice.chinese.v1alpha1.Article> getArticlesList() {
    return articles_;
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
   */
  public java.util.List<? extends gg.dsepractice.chinese.v1alpha1.ArticleOrBuilder> 
      getArticlesOrBuilderList() {
    return articles_;
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
   */
  @java.lang.Override
  public int getArticlesCount() {
    return articles_.size();
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
   */
  @java.lang.Override
  public gg.dsepractice.chinese.v1alpha1.Article getArticles(int index) {
    return articles_.get(index);
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
   */
  public gg.dsepractice.chinese.v1alpha1.ArticleOrBuilder getArticlesOrBuilder(
      int index) {
    return articles_.get(index);
  }
  private void ensureArticlesIsMutable() {
    com.google.protobuf.Internal.ProtobufList<gg.dsepractice.chinese.v1alpha1.Article> tmp = articles_;
    if (!tmp.isModifiable()) {
      articles_ =
          com.google.protobuf.GeneratedMessageLite.mutableCopy(tmp);
     }
  }

  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
   */
  private void setArticles(
      int index, gg.dsepractice.chinese.v1alpha1.Article value) {
    value.getClass();
  ensureArticlesIsMutable();
    articles_.set(index, value);
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
   */
  private void addArticles(gg.dsepractice.chinese.v1alpha1.Article value) {
    value.getClass();
  ensureArticlesIsMutable();
    articles_.add(value);
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
   */
  private void addArticles(
      int index, gg.dsepractice.chinese.v1alpha1.Article value) {
    value.getClass();
  ensureArticlesIsMutable();
    articles_.add(index, value);
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
   */
  private void addAllArticles(
      java.lang.Iterable<? extends gg.dsepractice.chinese.v1alpha1.Article> values) {
    ensureArticlesIsMutable();
    com.google.protobuf.AbstractMessageLite.addAll(
        values, articles_);
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
   */
  private void clearArticles() {
    articles_ = emptyProtobufList();
  }
  /**
   * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
   */
  private void removeArticles(int index) {
    ensureArticlesIsMutable();
    articles_.remove(index);
  }

  public static final int PAGINATION_INFO_FIELD_NUMBER = 2;
  private gg.dsepractice.chinese.v1alpha1.PaginationInfo paginationInfo_;
  /**
   * <code>.dsepractice.chinese.v1alpha1.PaginationInfo pagination_info = 2 [json_name = "paginationInfo"];</code>
   */
  @java.lang.Override
  public boolean hasPaginationInfo() {
    return paginationInfo_ != null;
  }
  /**
   * <code>.dsepractice.chinese.v1alpha1.PaginationInfo pagination_info = 2 [json_name = "paginationInfo"];</code>
   */
  @java.lang.Override
  public gg.dsepractice.chinese.v1alpha1.PaginationInfo getPaginationInfo() {
    return paginationInfo_ == null ? gg.dsepractice.chinese.v1alpha1.PaginationInfo.getDefaultInstance() : paginationInfo_;
  }
  /**
   * <code>.dsepractice.chinese.v1alpha1.PaginationInfo pagination_info = 2 [json_name = "paginationInfo"];</code>
   */
  private void setPaginationInfo(gg.dsepractice.chinese.v1alpha1.PaginationInfo value) {
    value.getClass();
  paginationInfo_ = value;
    
    }
  /**
   * <code>.dsepractice.chinese.v1alpha1.PaginationInfo pagination_info = 2 [json_name = "paginationInfo"];</code>
   */
  @java.lang.SuppressWarnings({"ReferenceEquality"})
  private void mergePaginationInfo(gg.dsepractice.chinese.v1alpha1.PaginationInfo value) {
    value.getClass();
  if (paginationInfo_ != null &&
        paginationInfo_ != gg.dsepractice.chinese.v1alpha1.PaginationInfo.getDefaultInstance()) {
      paginationInfo_ =
        gg.dsepractice.chinese.v1alpha1.PaginationInfo.newBuilder(paginationInfo_).mergeFrom(value).buildPartial();
    } else {
      paginationInfo_ = value;
    }
    
  }
  /**
   * <code>.dsepractice.chinese.v1alpha1.PaginationInfo pagination_info = 2 [json_name = "paginationInfo"];</code>
   */
  private void clearPaginationInfo() {  paginationInfo_ = null;
    
  }

  public static gg.dsepractice.chinese.v1alpha1.ListArticlesResponse parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data);
  }
  public static gg.dsepractice.chinese.v1alpha1.ListArticlesResponse parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data, extensionRegistry);
  }
  public static gg.dsepractice.chinese.v1alpha1.ListArticlesResponse parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data);
  }
  public static gg.dsepractice.chinese.v1alpha1.ListArticlesResponse parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data, extensionRegistry);
  }
  public static gg.dsepractice.chinese.v1alpha1.ListArticlesResponse parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data);
  }
  public static gg.dsepractice.chinese.v1alpha1.ListArticlesResponse parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, data, extensionRegistry);
  }
  public static gg.dsepractice.chinese.v1alpha1.ListArticlesResponse parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input);
  }
  public static gg.dsepractice.chinese.v1alpha1.ListArticlesResponse parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input, extensionRegistry);
  }
  public static gg.dsepractice.chinese.v1alpha1.ListArticlesResponse parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return parseDelimitedFrom(DEFAULT_INSTANCE, input);
  }
  public static gg.dsepractice.chinese.v1alpha1.ListArticlesResponse parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return parseDelimitedFrom(DEFAULT_INSTANCE, input, extensionRegistry);
  }
  public static gg.dsepractice.chinese.v1alpha1.ListArticlesResponse parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input);
  }
  public static gg.dsepractice.chinese.v1alpha1.ListArticlesResponse parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageLite.parseFrom(
        DEFAULT_INSTANCE, input, extensionRegistry);
  }

  public static Builder newBuilder() {
    return (Builder) DEFAULT_INSTANCE.createBuilder();
  }
  public static Builder newBuilder(gg.dsepractice.chinese.v1alpha1.ListArticlesResponse prototype) {
    return (Builder) DEFAULT_INSTANCE.createBuilder(prototype);
  }

  /**
   * Protobuf type {@code dsepractice.chinese.v1alpha1.ListArticlesResponse}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageLite.Builder<
        gg.dsepractice.chinese.v1alpha1.ListArticlesResponse, Builder> implements
      // @@protoc_insertion_point(builder_implements:dsepractice.chinese.v1alpha1.ListArticlesResponse)
      gg.dsepractice.chinese.v1alpha1.ListArticlesResponseOrBuilder {
    // Construct using gg.dsepractice.chinese.v1alpha1.ListArticlesResponse.newBuilder()
    private Builder() {
      super(DEFAULT_INSTANCE);
    }


    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
     */
    @java.lang.Override
    public java.util.List<gg.dsepractice.chinese.v1alpha1.Article> getArticlesList() {
      return java.util.Collections.unmodifiableList(
          instance.getArticlesList());
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
     */
    @java.lang.Override
    public int getArticlesCount() {
      return instance.getArticlesCount();
    }/**
     * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
     */
    @java.lang.Override
    public gg.dsepractice.chinese.v1alpha1.Article getArticles(int index) {
      return instance.getArticles(index);
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
     */
    public Builder setArticles(
        int index, gg.dsepractice.chinese.v1alpha1.Article value) {
      copyOnWrite();
      instance.setArticles(index, value);
      return this;
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
     */
    public Builder setArticles(
        int index, gg.dsepractice.chinese.v1alpha1.Article.Builder builderForValue) {
      copyOnWrite();
      instance.setArticles(index,
          builderForValue.build());
      return this;
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
     */
    public Builder addArticles(gg.dsepractice.chinese.v1alpha1.Article value) {
      copyOnWrite();
      instance.addArticles(value);
      return this;
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
     */
    public Builder addArticles(
        int index, gg.dsepractice.chinese.v1alpha1.Article value) {
      copyOnWrite();
      instance.addArticles(index, value);
      return this;
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
     */
    public Builder addArticles(
        gg.dsepractice.chinese.v1alpha1.Article.Builder builderForValue) {
      copyOnWrite();
      instance.addArticles(builderForValue.build());
      return this;
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
     */
    public Builder addArticles(
        int index, gg.dsepractice.chinese.v1alpha1.Article.Builder builderForValue) {
      copyOnWrite();
      instance.addArticles(index,
          builderForValue.build());
      return this;
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
     */
    public Builder addAllArticles(
        java.lang.Iterable<? extends gg.dsepractice.chinese.v1alpha1.Article> values) {
      copyOnWrite();
      instance.addAllArticles(values);
      return this;
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
     */
    public Builder clearArticles() {
      copyOnWrite();
      instance.clearArticles();
      return this;
    }
    /**
     * <code>repeated .dsepractice.chinese.v1alpha1.Article articles = 1 [json_name = "articles"];</code>
     */
    public Builder removeArticles(int index) {
      copyOnWrite();
      instance.removeArticles(index);
      return this;
    }

    /**
     * <code>.dsepractice.chinese.v1alpha1.PaginationInfo pagination_info = 2 [json_name = "paginationInfo"];</code>
     */
    @java.lang.Override
    public boolean hasPaginationInfo() {
      return instance.hasPaginationInfo();
    }
    /**
     * <code>.dsepractice.chinese.v1alpha1.PaginationInfo pagination_info = 2 [json_name = "paginationInfo"];</code>
     */
    @java.lang.Override
    public gg.dsepractice.chinese.v1alpha1.PaginationInfo getPaginationInfo() {
      return instance.getPaginationInfo();
    }
    /**
     * <code>.dsepractice.chinese.v1alpha1.PaginationInfo pagination_info = 2 [json_name = "paginationInfo"];</code>
     */
    public Builder setPaginationInfo(gg.dsepractice.chinese.v1alpha1.PaginationInfo value) {
      copyOnWrite();
      instance.setPaginationInfo(value);
      return this;
      }
    /**
     * <code>.dsepractice.chinese.v1alpha1.PaginationInfo pagination_info = 2 [json_name = "paginationInfo"];</code>
     */
    public Builder setPaginationInfo(
        gg.dsepractice.chinese.v1alpha1.PaginationInfo.Builder builderForValue) {
      copyOnWrite();
      instance.setPaginationInfo(builderForValue.build());
      return this;
    }
    /**
     * <code>.dsepractice.chinese.v1alpha1.PaginationInfo pagination_info = 2 [json_name = "paginationInfo"];</code>
     */
    public Builder mergePaginationInfo(gg.dsepractice.chinese.v1alpha1.PaginationInfo value) {
      copyOnWrite();
      instance.mergePaginationInfo(value);
      return this;
    }
    /**
     * <code>.dsepractice.chinese.v1alpha1.PaginationInfo pagination_info = 2 [json_name = "paginationInfo"];</code>
     */
    public Builder clearPaginationInfo() {  copyOnWrite();
      instance.clearPaginationInfo();
      return this;
    }

    // @@protoc_insertion_point(builder_scope:dsepractice.chinese.v1alpha1.ListArticlesResponse)
  }
  @java.lang.Override
  @java.lang.SuppressWarnings({"unchecked", "fallthrough"})
  protected final java.lang.Object dynamicMethod(
      com.google.protobuf.GeneratedMessageLite.MethodToInvoke method,
      java.lang.Object arg0, java.lang.Object arg1) {
    switch (method) {
      case NEW_MUTABLE_INSTANCE: {
        return new gg.dsepractice.chinese.v1alpha1.ListArticlesResponse();
      }
      case NEW_BUILDER: {
        return new Builder();
      }
      case BUILD_MESSAGE_INFO: {
          java.lang.Object[] objects = new java.lang.Object[] {
            "articles_",
            gg.dsepractice.chinese.v1alpha1.Article.class,
            "paginationInfo_",
          };
          java.lang.String info =
              "\u0000\u0002\u0000\u0000\u0001\u0002\u0002\u0000\u0001\u0000\u0001\u001b\u0002\t" +
              "";
          return newMessageInfo(DEFAULT_INSTANCE, info, objects);
      }
      // fall through
      case GET_DEFAULT_INSTANCE: {
        return DEFAULT_INSTANCE;
      }
      case GET_PARSER: {
        com.google.protobuf.Parser<gg.dsepractice.chinese.v1alpha1.ListArticlesResponse> parser = PARSER;
        if (parser == null) {
          synchronized (gg.dsepractice.chinese.v1alpha1.ListArticlesResponse.class) {
            parser = PARSER;
            if (parser == null) {
              parser =
                  new DefaultInstanceBasedParser<gg.dsepractice.chinese.v1alpha1.ListArticlesResponse>(
                      DEFAULT_INSTANCE);
              PARSER = parser;
            }
          }
        }
        return parser;
    }
    case GET_MEMOIZED_IS_INITIALIZED: {
      return (byte) 1;
    }
    case SET_MEMOIZED_IS_INITIALIZED: {
      return null;
    }
    }
    throw new UnsupportedOperationException();
  }


  // @@protoc_insertion_point(class_scope:dsepractice.chinese.v1alpha1.ListArticlesResponse)
  private static final gg.dsepractice.chinese.v1alpha1.ListArticlesResponse DEFAULT_INSTANCE;
  static {
    ListArticlesResponse defaultInstance = new ListArticlesResponse();
    // New instances are implicitly immutable so no need to make
    // immutable.
    DEFAULT_INSTANCE = defaultInstance;
    com.google.protobuf.GeneratedMessageLite.registerDefaultInstance(
      ListArticlesResponse.class, defaultInstance);
  }

  public static gg.dsepractice.chinese.v1alpha1.ListArticlesResponse getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static volatile com.google.protobuf.Parser<ListArticlesResponse> PARSER;

  public static com.google.protobuf.Parser<ListArticlesResponse> parser() {
    return DEFAULT_INSTANCE.getParserForType();
  }
}

